import { Component, OnInit } from '@angular/core';
import { ToastrService } from 'ngx-toastr';
import { AlertService } from 'src/app/services/alert.service';
import { Tesrpmservice} from './Tesrpm.service';
import { AbstractControl, FormArray, FormBuilder, FormGroup, Validators, ValidationErrors } from '@angular/forms';
import { ExtensionService } from 'src/app/services/fnd/extension.service';
import { DashboardContentModel2 } from 'src/app/models/builder/dashboard'; 
import { Tesrpmcardvariable } from './Tesrpm_cardvariable';
import { UserInfoService } from 'src/app/services/user-info.service';
declare var JsBarcode: any; 
@Component({
  selector: 'app-Tesrpm',
  templateUrl: './Tesrpm.component.html',
  styleUrls: ['./Tesrpm.component.scss']
})
export class TesrpmComponent implements OnInit {
  cardButton = Tesrpmcardvariable.cardButton;
  cardmodeldata = Tesrpmcardvariable.cardmodeldata;
  public dashboardArray: DashboardContentModel2[];
  isCardview = Tesrpmcardvariable.cardButton;
  cardmodal;  changeView(){
  this.isCardview = !this.isCardview;
  }
    beforeText(fieldtext: string): string { // Extract the text before the first '<'
    const index = fieldtext.indexOf('<');
    return index !== -1 ? fieldtext.substring(0, index) : fieldtext;
  }
  afterText(fieldtext: string): string { // Extract the text after the last '>'
    const index = fieldtext.lastIndexOf('>');
    return index !== -1 ? fieldtext.substring(index + 1) : '';
  }
  transform(fieldtext: string): string {
    const match = fieldtext.match(/<([^>]*)>/);
    return match ? match[1] : ''; // Extract the text between '<' and '>'
  }
 userrole;
  rowSelected :any= {};
  modaldelete=false;
  modalEdit=false;
  modalAdd= false;
  public entryForm: FormGroup;
  loading = false;
  product;
  modalOpenedforNewLine = false;
  newLine:any;
 additionalFieldsFromBackend: any[] = [];
  formcode = 'Tesrpm_formCode'
tableName = 'Tesrpm';  checkFormCode; selected: any[] = []; constructor(
    private extensionService: ExtensionService,
private userInfoService:UserInfoService,
    private mainService:Tesrpmservice,
    private alertService: AlertService,
    private toastr: ToastrService,
    private _fb: FormBuilder,
  ) { }
// component button 
  ngOnInit(): void {
    if(this.cardmodeldata !== ''){
     this.cardmodal = JSON.parse(this.cardmodeldata);
    this.dashboardArray = this.cardmodal.dashboard.slice();
    console.log(this.dashboardArray)
    }
    this.userrole=this.userInfoService.getRoles();
    this.getData();
    this.entryForm = this._fb.group({
name : [null],

number1 : [null,[Validators.required]],

number2 : [null,[Validators.required]],




 







  }); // component_button200
 // form code start
    this.extensionService.getJsonObjectsByFormCodeList(this.formcode).subscribe(data => {
      console.log(data);
      const jsonArray = data.map((str) => JSON.parse(str));
      this.additionalFieldsFromBackend = jsonArray;
      this.checkFormCode = this.additionalFieldsFromBackend.some(field => field.formCode === "Tesrpm_formCode");
      console.log(this.checkFormCode);
      console.log(this.additionalFieldsFromBackend);
      if (this.additionalFieldsFromBackend && this.additionalFieldsFromBackend.length > 0) {
        this.additionalFieldsFromBackend.forEach(field => {
          if (field.formCode === this.formcode) {
            if (!this.entryForm.contains(field.extValue)) {
              // Add the control only if it doesn't exist in the form
              this.entryForm.addControl(field.extValue, this._fb.control(field.fieldValue));
            }
          }
        });
      }
    });
    console.log(this.entryForm.value);
    // form code end 









  }








 error; 
  getData() {
    this.mainService.getAll().subscribe((data) => {
      console.log(data);
      this.product = data;
 if(this.product.length==0){
        this.error="No Data Available"
     }   
    },(error) => {
      console.log(error);
      if(error){
       this.error="Server Error";
     }
    });
  }
  onEdit(row) {
    this.rowSelected = row;






//calculated field start
	
 
	   this.calculatedaddnumber1= row.number1;
	  

 
	   this.calculatedaddnumber2= row.number2;
	  

//calculated field end


    this.modalEdit = true;
  }
   onDelete(row) {
    this.rowSelected = row;
     this.modaldelete=true;
  }
  delete(id)
  {
    this.modaldelete = false;
    console.log("in delete  "+id);
    this.mainService.delete(id).subscribe(
      (data) => {
        console.log(data);
        this.ngOnInit();
  if (data) {				      this.toastr.success('Deleted successfully');      }
    });
  }
    onUpdate(id) {
    this.modalEdit = false;






//calculated field start
	
 
this.rowSelected.number1= this.calculatedaddnumber1;
	 

 
this.rowSelected.number2= this.calculatedaddnumber2;
	 

this.onInputChangecalculatedadd ();
 //calculated field end

    //console.log("in update");
    console.log("id  " + id);
    console.log(this.rowSelected);
    //console.log("out update");
    this.mainService.update(id, this.rowSelected).subscribe(
      (data) => {
        console.log(data);
        if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Update Successfully");
        }
setTimeout(() => {
      this.ngOnInit();
    }, 500);








      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("update Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Updated");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Updated");
        }
      });
    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  } 
onCreate() {
     this.modalAdd=false;






//calculated field start
	
 
this.entryForm.value.number1  = this.calculatedaddnumber1 ;
	  

 
this.entryForm.value.number2  = this.calculatedaddnumber2 ;
	  

//calculated field end

  this.mainService.create(this.entryForm.value).subscribe(
    (data) => {
      console.log(data);
  if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Added Successfully");
        }
setTimeout(() => {
      this.ngOnInit();
    }, 500);








      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("Added Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Added");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Added");
        }
      });
    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  }
  goToAdd(row) {
this.modalAdd = true; this.submitted = false;





  //calculated field start

  
 
  this.calculatedaddnumber1  = '';
 

 
  this.calculatedaddnumber2  = '';
 



  this.calculatedaddtotal = '';

  //calculated field end


  }
 submitted = false;
onSubmit() {
  console.log(this.entryForm.value);
 this.submitted = true;
  if (this.entryForm.invalid) {
    return;
  }this.onCreate();

} 






 // calculated field code start 

 
 calculatedaddnumber1; 
  

 
 calculatedaddnumber2; 
  

  calculatedaddtotal ; 
 calculatedaddcalculateOperators = "Addition"
onInputChangecalculatedadd() {
const lastObj = 0
const lastObjstring = ''
	
 

    const number1= this.calculatedaddnumber1|| '';

	const number1Value = parseFloat(this.calculatedaddnumber1) || 0;

	  

 

    const number2= this.calculatedaddnumber2|| '';

	const number2Value = parseFloat(this.calculatedaddnumber2) || 0;

	  

if (this.calculatedaddcalculateOperators =="Addition") {
 this.calculatedaddtotal = (   
	
 
		 number1Value +
	 

 
		 number2Value +
	 
 lastObj).toString();
}
if (this.calculatedaddcalculateOperators == "Subtraction") {
	 this.calculatedaddtotal = (   

 
 number1Value   -
	 

 
 number2Value   -
	 

	lastObj).toString();
}
if (this.calculatedaddcalculateOperators =="Multiplication") {
  this.calculatedaddtotal = (

	
 
	number1Value *
		 

 
	number2Value *
		 

lastObj).toString();
}
if (this.calculatedaddcalculateOperators =="Division") {
 
	this.calculatedaddtotal = ( 

 
number1Value   /
	 

 
number2Value   /
	 

lastObj).toString();

}
if (this.calculatedaddcalculateOperators =="Concatination") {
 this.calculatedaddtotal =  

 
number1+ ' '+
	 

 
number2+ ' '+
	 
 lastObjstring 
}
}

// updateaction
}







